Package com.io7m.waxmill.xml.config.v1

# Class WXM1Paths

java.lang.Object
com.io7m.waxmill.xml.config.v1.WXM1Paths

All Implemented Interfaces:
  `WXM1PathsType`

    public final class WXM1Paths
    extends java.lang.Object
    implements WXM1PathsType

Immutable implementation of `WXM1PathsType`.

Use the builder to create immutable instances: `WXM1Paths.builder()`. Use the static factory method to create immutable instances: `WXM1Paths.of()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXM1Paths.Builder` | Builds instances of type `WXM1Paths`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXM1Paths.Builder` | `builder()` | Creates a builder for `WXM1Paths`.
  `static WXM1Paths` | `copyOf​(WXM1PathsType instance)` | Creates an immutable copy of a `WXM1PathsType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXM1Paths` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `paths`, `pathMap`.
  `static WXM1Paths` | `of​(java.lang.Iterable<? extends WXM1Path> paths)` | Construct a new immutable `WXM1Paths` instance.
  `static WXM1Paths` | `of​(java.util.List<WXM1Path> paths)` | Construct a new immutable `WXM1Paths` instance.
  `java.util.Map<java.lang.String,​WXM1Path>` | `pathMap()` |
  `java.util.List<WXM1Path>` | `paths()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXM1Paths` with attribute values.
  `WXM1Paths` | `withPaths​(WXM1Path... elements)` | Copy the current immutable object with elements that replace the content of `paths`.
  `WXM1Paths` | `withPaths​(java.lang.Iterable<? extends WXM1Path> elements)` | Copy the current immutable object with elements that replace the content of `paths`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### paths

    public java.util.List<WXM1Path> paths()
    Specified by:
      `paths` in interface `WXM1PathsType`
    Returns:
      The value of the `paths` attribute

  - ### pathMap

    public java.util.Map<java.lang.String,​WXM1Path> pathMap()
    Specified by:
      `pathMap` in interface `WXM1PathsType`
    Returns:
      The computed-at-construction value of the `pathMap` attribute

  - ### withPaths

    public final WXM1Paths withPaths​(WXM1Path... elements)
    Copy the current immutable object with elements that replace the content of `paths`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withPaths

    public final WXM1Paths withPaths​(java.lang.Iterable<? extends WXM1Path> elements)
    Copy the current immutable object with elements that replace the content of `paths`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of paths elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXM1Paths` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `paths`, `pathMap`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXM1Paths` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static WXM1Paths of​(java.util.List<WXM1Path> paths)
    Construct a new immutable `WXM1Paths` instance.
    Parameters:
      `paths` - The value for the `paths` attribute
    Returns:
      An immutable WXM1Paths instance

  - ### of

    public static WXM1Paths of​(java.lang.Iterable<? extends WXM1Path> paths)
    Construct a new immutable `WXM1Paths` instance.
    Parameters:
      `paths` - The value for the `paths` attribute
    Returns:
      An immutable WXM1Paths instance

  - ### copyOf

    public static WXM1Paths copyOf​(WXM1PathsType instance)
    Creates an immutable copy of a `WXM1PathsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXM1Paths instance

  - ### builder

    public static WXM1Paths.Builder builder()
    Creates a builder for `WXM1Paths`.

         WXM1Paths.builder()
            .addPaths|addAllPaths(WXM1Path) // paths elements
            .build();

    Returns:
      A new WXM1Paths builder